function sysClose
/* Enables or disables the "close" item on the system menu as well 
   as the Win95 X.

   Syntax:    sysClose( oForm, lEnabled )
   Example: sysClose( _app.FrameWin, false )

   Returns the previous state of the menu item.
   Posted to the newagroups by Gary White.  
*/
parameters oForm, lEnabled
local hMenu, lRetVal
#define MF_ENABLED      0x00000000
#define MF_GRAYED       0x00000001
#define SC_CLOSE        0xF060

   if argCount() # 2 or ;
         type("oForm.hWnd") # "N" ;
         or type("lEnabled") # "L"
      msgbox( "Correct syntax is:  sysClose( oForm, lEnabled )", ;
         "Error", 16 )
      return
   endif
   if empty( oForm.hWnd )
      msgbox( "Form is not open", "Error", 16 )
      return
   endif

   if type( "GetSystemMenu" ) # "FP"
     extern cint GetSystemMenu( cHandle, cInt ) USER32
   endif
   if type( "EnableMenuItem" ) # "FP"
      extern CLOGICAL EnableMenuItem( cHandle, cInt, cInt) user32
   endif
        hMenu = GetSystemMenu( oForm.hWnd, 0 )
   if lEnabled
        lRetVal = EnableMenuItem( hMenu, SC_CLOSE, MF_ENABLED )
   else
        lRetVal = EnableMenuItem( hMenu, SC_CLOSE, MF_GRAYED )
        endif
   return not lRetVal