***************************************************************************
*  Copyright (C) 1998 Marcello Perathoner. All rights reserved.           *
*  email: JLSeagull@csi.com                                               *
*  http://ourworld.compuserve.com/Homepages/JLSeagull/vdb/index.html      *
***************************************************************************

#define NDEBUG

* close all ; do hlcomdlg.cc ; hlcomdlgtestsuite ()

   set procedure to program (1) additive
   InitHLComDlg ()
   * HLComDlgTestSuite ()
RETURN

#include "hlstruct.cch"
#include "hlcomdlg.cch"
#include "hlprint.cch"

#ifdef __vdb__
   #define COMDLG   comdlg32.dll
#else
   #define COMDLG   commdlg.dll
#endif

#define int		CINT
#define HWND 	HWINDOW

PROCEDURE InitHLComDlg
   DO ("hlwinapi.cc")
   DO ("hlstruct.cc")
   DO ("hlprint.cc")

   IF type ("WinAPICommDlgExtendedError") == "FP"
      RETURN
   ENDIF

   extern CLONG   WinAPICommDlgExtendedError (CVOID)                 COMDLG from "CommDlgExtendedError"
   extern BOOL    WinAPIGetOpenFileName      (LPSTRUCT)              COMDLG from "GetOpenFileName" U
   extern BOOL    WinAPIGetSaveFileName      (LPSTRUCT)              COMDLG from "GetSaveFileName" U
   extern int     WinAPIGetFileTitle         (LPCSTR, LPSTR, UINT)   COMDLG from "GetFileTitle" U
   extern HWND    WinAPIFindText             (LPSTRUCT)              COMDLG from "FindText" U
   extern HWND    WinAPIReplaceText          (LPSTRUCT)              COMDLG from "ReplaceText" U
   extern BOOL    WinAPIChooseFont           (LPSTRUCT)              COMDLG from "ChooseFont" U
   extern BOOL    WinAPIChooseColor          (LPSTRUCT)              COMDLG from "ChooseColor" U
   extern BOOL    WinAPIPrintDlg             (LPSTRUCT)              COMDLG from "PrintDlg" U
#ifdef __vdb__
   extern BOOL    WinAPIPageSetupDlg         (LPSTRUCT)              COMDLG from "PageSetupDlg" U
#endif
RETURN

#undef HWND
#undef int

************************************************************************
* The structures
************************************************************************

CLASS HLS_DEVNAMES OF HLStruct
   * the brain-deadest "structure" ever
   protect wDriverOffset, wDeviceOffset, wOutputOffset, Strings
   HLS_WORD("wDriverOffset")
   HLS_WORD("wDeviceOffset")
   HLS_WORD("wOutputOffset")
   HLS_WORD("wDefault")
   this.sizesofar = this.GetSize ()
   new HLSByteArray (new HLSAnsiDecorator (this), "Strings", 260 + 32 + 32)
   * HLS_BYTES("Strings", 260 + 32 + 32)
   this.LoadDefaults ()

   PROCEDURE Put_ (oMem, nOffs)
      this.Strings         = this.cDriver + chr (0) + this.cDevice + chr (0) + this.cOutput
      this.wDriverOffset   = this.sizesofar
      this.wDeviceOffset   = this.sizesofar + len (this.cDriver) + 1
      this.wOutputOffset   = this.sizesofar + len (this.cDriver) + len (this.cDevice) + 2
      this.wDefault        = iif (this.lDefault, DN_DEFAULTPRN, 0)
      super::Put_ (oMem, nOffs)
   RETURN

   PROCEDURE GetAtOffset (nOffs)
      nOffs = nOffs - this.sizesofar + 1
      LOCAL s ; s = substr (this.Strings, nOffs)
      LOCAL pos ; pos = at (chr (0), s)
      * ? this.Strings, nOffs, pos
      IF pos <> -1
         RETURN left (s, pos - 1)
      ENDIF
   RETURN ""

   PROCEDURE Get_ (oMem, nOffs)
      super::Get_ (oMem, nOffs)
      * oMem.PrintHex (0)
      this.cDriver = this.GetAtOffset (this.wDriverOffset)
      this.cDevice = this.GetAtOffset (this.wDeviceOffset)
      this.cOutput = this.GetAtOffset (this.wOutputOffset)
      this.lDefault = bitand (this.wDefault, DN_DEFAULTPRN) <> 0
   RETURN

   PROCEDURE LoadDefaults
      * gets default printer from WIN.INI
      local cBuffer ; cBuffer = space (8192)
      local nLen ; nLen = WinAPIGetProfileString ("Windows", "Device", "", cBuffer, len (cBuffer))
      IF nLen > 0
         this.FromCommaSeparated (left (cBuffer, nLen))
         this.lDefault = true
      ELSE
         this.cDevice  = ""
         this.cDriver  = ""
         this.cPort    = ""
         this.lDefault = false
      ENDIF
   RETURN

   PROCEDURE Equal (odnRef)
   RETURN this.cDevice == odnRef.cDevice .and. ;
          this.cDriver == odnRef.cDriver .and. ;
          this.cOutput == odnRef.cOutput

   PROCEDURE FromCommaSeparated (cCS)
      local a ; a = tokenize (cCS, ",")
      IF alen (a) == 3
         this.cDevice = a [1]
         this.cDriver = a [2]
         this.cOutput = a [3]
      ENDIF
   RETURN

   PROCEDURE ToCommaSeparated
   RETURN this.cDevice + "," + this.cDriver + "," + this.cOutput
ENDCLASS

CLASS HLS_OPENFILENAME OF HLStruct
   HLS_DWORD("lStructSize")
   HLS_HWND("hWndOwner")
   HLS_HINSTANCE("hInstance")
   HLS_LPCTSTR("lpstrFilter")
   HLS_LPTSTR("lpstrCustomFilter")
   HLS_DWORD("nMaxCustFilter")
   HLS_DWORD("nFilterIndex")
   HLS_LPTSTR("lpstrFile")
   HLS_DWORD("nMaxFile")
   HLS_LPTSTR("lpstrFileTitle")
   HLS_DWORD("nMaxFileTitle")
   HLS_LPCTSTR("lpstrInitialDir")
   HLS_LPCTSTR("lpstrTitle")
   HLS_DWORD("Flags")
   HLS_WORD("nFileOffset")
   HLS_WORD("nFileExtension")
   HLS_LPCTSTR("lpstrDefExt")
   HLS_LPARAM("lCustData")
   HLS_LPHOOK("lpfnHook")
   HLS_LPCTSTR("lpTemplateName")

   this.lStructSize  = this.GetSize ()
   * set some "meaningful" defaults
   this.lpstrFilter  = "All Files (*.*)" + chr (0) + "*.*" + chr (0) + chr (0)
   this.nFilterIndex = 1
   this.lpstrFile    = chr (0) + space (259)
   this.nMaxFile     = 260

   PROCEDURE ExecDialog
      IF WinAPIGetOpenFileName (this.put ())
         this.get ()
      ELSE
         this.ErrorMessage = HLComDlgErrorMessage ()
         RETURN false
      ENDIF
   RETURN true
ENDCLASS

CLASS HLS_CHOOSEFONT OF HLStruct
   HLS_DWORD("lStructSize")
   HLS_HWND("hwndOwner")
   HLS_HDC("hDC")
   HLS_LPSTRUCT("lpLogFont", new HLS_LOGFONT ())
   HLS_INT("iPointSize")
   HLS_DWORD("Flags")
   HLS_DWORD("rgbColors")
   HLS_LPARAM("lCustData")
   HLS_LPHOOK("lpfnHook")
   HLS_LPCTSTR("lpTemplateName")
   HLS_HINSTANCE("hInstance")
   HLS_LPTSTR("lpszStyle")
   HLS_UINT("nFontType")
   HLS_INT("nSizeMin")
   HLS_INT("nSizeMax")

   this.lStructSize = this.GetSize ()
   * set some "meaningful" defaults
   this.Flags  = CF_BOTH

   PROCEDURE ExecDialog
      IF WinAPIChooseFont (this.put ())
         this.get ()
      ELSE
         this.ErrorMessage = HLComDlgErrorMessage ()
         RETURN false
      ENDIF
   RETURN true
ENDCLASS

CLASS HLS_COLORREF16 OF HLStruct
   * build an array of 16 COLORREFs
   * (which in turn are DWORDs)
   LOCAL i
   FOR i = 0 TO 15
      HLS_DWORD(i)
   NEXT
ENDCLASS

CLASS HLS_CHOOSECOLOR OF HLStruct
   * build CHOOSECOLOR
   HLS_DWORD("lStructSize")
   HLS_HWND("hwndOwner")
   HLS_HWND("hInstance")
   HLS_DWORD("rgbResult")
   HLS_LPSTRUCT("lpCustColors", new HLS_COLORREF16 ()) && array of 16 COLORREFs
   HLS_DWORD("Flags")
   HLS_LPARAM("lCustData")
   HLS_LPHOOK("lpfnHook")
   HLS_LPCTSTR("lpTemplateName")

   this.lStructSize = this.GetSize ()

   PROCEDURE ExecDialog
      IF WinAPIChooseColor (this.put ())
         this.get ()
      ELSE
         this.ErrorMessage = HLComDlgErrorMessage ()
         RETURN false
      ENDIF
   RETURN true
ENDCLASS

CLASS HLS_PRINTDLG (oDevMode, oDevNames) OF HLStruct
   HLS_DWORD("lStructSize")
   HLS_HWND("hwndOwner")
   HLS_HGLOBALSTRUCT("hDevMode", oDevMode)
   HLS_HGLOBALSTRUCT("hDevNames", oDevNames)
   HLS_HDC("hDC")
   HLS_DWORD("Flags")
   HLS_WORD("nFromPage")
   HLS_WORD("nToPage")
   HLS_WORD("nMinPage")
   HLS_WORD("nMaxPage")
   HLS_WORD("nCopies")
   HLS_HINSTANCE("hInstance")
   HLS_DWORD("lCustData")
   HLS_LPHOOK("lpfnPrintHook")
   HLS_LPHOOK("lpfnSetupHook")
   HLS_LPCTSTR("lpPrintTemplateName")
   HLS_LPCTSTR("lpSetupTemplateName")
   HLS_HANDLE("hPrintTemplate")
   HLS_HANDLE("hSetupTemplate")

   this.lStructSize = this.GetSize ()
   * set some "meaningful" defaults
   * this.Flags     = PD_PAGENUMS
   this.nFromPage = 1
   this.nToPage   = -1
   this.nMinPage  = 1
   this.nMaxPage  = -1
   this.nCopies   = 1

   PROCEDURE ExecDialog
      IF WinAPIPrintDlg (this.put ())
         this.get ()
      ELSE
         * must call get () after put () otherwise we will orphan the HGlobs
         this.get ()
         this.ErrorMessage = HLComDlgErrorMessage ()
         RETURN false
      ENDIF
   RETURN true
ENDCLASS

CLASS HLS_PAGESETUPDLG (oDevMode, oDevNames) OF HLStruct
   HLS_DWORD("lStructSize")
   HLS_HWND("hwndOwner")
   HLS_HGLOBALSTRUCT("hDevMode", oDevMode)
   HLS_HGLOBALSTRUCT("hDevNames", oDevNames)
   HLS_DWORD("Flags")
   HLS_INLINEDSTRUCT("ptPaperSize", new HLS_POINT ())
   HLS_INLINEDSTRUCT("rtMinMargin", new HLS_RECT ())
   HLS_INLINEDSTRUCT("rtMargin", new HLS_RECT ())
   HLS_HINSTANCE("hInstance")
   HLS_LPARAM("lCustData")
   HLS_LPHOOK("lpfnPageSetupHook")
   HLS_LPHOOK("lpfnPagePaintHook")
   HLS_LPCTSTR("lpPageSetupTemplateName")
   HLS_HGLOBAL("hPageSetupTemplate")

   this.lStructSize = this.GetSize ()

   PROCEDURE ExecDialog
      IF WinAPIPageSetupDlg (this.put ())
         this.get ()
      ELSE
         * must call this after put otherwise we will orphan the HGlobs
         this.get ()
         this.ErrorMessage = HLComDlgErrorMessage ()
         RETURN false
      ENDIF
   RETURN true
ENDCLASS

CLASS HLS_FINDREPLACE OF HLStruct
   HLS_DWORD("lStructSize")
   HLS_HWND("hwndOwner")
   HLS_HINSTANCE("hInstance")
   HLS_DWORD("Flags")
   HLS_LPTSTR("lpstrFindWhat")
   HLS_LPTSTR("lpstrReplaceWith")
   HLS_WORD("wFindWhatLen")
   HLS_WORD("wReplaceWithLen")
   HLS_LPARAM("lCustData")
   HLS_LPHOOK("lpfnHook")
   HLS_LPCTSTR("lpTemplateName")

   this.lStructSize = this.GetSize ()
ENDCLASS

PROCEDURE HLComDlgErrorMessage
RETURN HLComDlgErrorToMessage (WinAPICommDlgExtendedError ())

PROCEDURE HLComDlgErrorToMessage (nErrCode)
   DO CASE
      case nErrCode = 0
         RETURN "No Error"
      case nErrCode = CDERR_DIALOGFAILURE
         RETURN "The common dialog box could not be created. The common dialog box function's call to the DialogBox function failed. For example, this error occurs if the common dialog box call specifies an invalid window handle."
      case nErrCode = CDERR_FINDRESFAILURE
         RETURN "The common dialog box function failed to find a specified resource."
      case nErrCode = CDERR_INITIALIZATION
         RETURN "The common dialog box function failed during initialization. This error often occurs when sufficient memory is not available."
      case nErrCode = CDERR_LOADRESFAILURE
         RETURN "The common dialog box function failed to load a specified resource."
      case nErrCode = CDERR_LOADSTRFAILURE
         RETURN "The common dialog box function failed to load a specified string."
      case nErrCode = CDERR_LOCKRESFAILURE
         RETURN "The common dialog box function failed to lock a specified resource."
      case nErrCode = CDERR_MEMALLOCFAILURE
         RETURN "The common dialog box function was unable to allocate memory for internal structures."
      case nErrCode = CDERR_MEMLOCKFAILURE
         RETURN "The common dialog box function was unable to lock the memory associated with a handle."
      case nErrCode = CDERR_NOHINSTANCE
         RETURN "The ENABLETEMPLATE flag was set in the Flags member of the initialization structure for the corresponding common dialog box, but you failed to provide a corresponding instance handle."
      case nErrCode = CDERR_NOHOOK
         RETURN "The ENABLEHOOK flag was set in the Flags member of the initialization structure for the corresponding common dialog box, but you failed to provide a pointer to a corresponding hook procedure."
      case nErrCode = CDERR_NOTEMPLATE
         RETURN "The ENABLETEMPLATE flag was set in the Flags member of the initialization structure for the corresponding common dialog box, but you failed to provide a corresponding template."
      case nErrCode = CDERR_REGISTERMSGFAIL
         RETURN "The RegisterWindowMessage function returned an error code when it was called by the common dialog box function."
      case nErrCode = CDERR_STRUCTSIZE
         RETURN "The lStructSize member of the initialization structure for the corresponding common dialog box is invalid."
      case nErrCode = PDERR_CREATEICFAILURE
         RETURN "The PrintDlg function failed when it attempted to create an information context."
      case nErrCode = PDERR_DEFAULTDIFFERENT
         RETURN "You called the PrintDlg function with the DN_DEFAULTPRN flag specified in the wDefault member of the DEVNAMES structure, but the printer described by the other structure members did not match the current default printer. (This error occurs when you store the DEVNAMES structure and the user changes the default printer by using the Control Panel.) To use the printer described by the DEVNAMES structure, clear the DN_DEFAULTPRN flag and call PrintDlg again. To use the default printer, replace the DEVNAMES structure (and the DEVMODE structure, if one exists) with NULL; and call PrintDlg again."
      case nErrCode = PDERR_DNDMMISMATCH
         RETURN "The data in the DEVMODE and DEVNAMES structures describes two different printers."
      case nErrCode = PDERR_GETDEVMODEFAIL
         RETURN "The printer driver failed to initialize a DEVMODE structure. (This error code applies only to printer drivers written for Windows versions 3.0 and later.)"
      case nErrCode = PDERR_INITFAILURE
         RETURN "The PrintDlg function failed during initialization, and there is no more specific extended error code to describe the failure. This is the generic default error code for the function."
      case nErrCode = PDERR_LOADDRVFAILURE
         RETURN "The PrintDlg function failed to load the device driver for the specified printer."
      case nErrCode = PDERR_NODEFAULTPRN
         RETURN "A default printer does not exist."
      case nErrCode = PDERR_NODEVICES
         RETURN "No printer drivers were found."
      case nErrCode = PDERR_PARSEFAILURE
         RETURN "The PrintDlg function failed to parse the strings in the [devices] section of the WIN.INI file."
      case nErrCode = PDERR_PRINTERNOTFOUND
         RETURN "The [devices] section of the WIN.INI file did not contain an entry for the requested printer."
      case nErrCode = PDERR_RETDEFFAILURE
         RETURN "The PD_RETURNDEFAULT flag was specified in the Flags member of the PRINTDLG structure, but the hDevMode or hDevNames member was not NULL."
      case nErrCode = PDERR_SETUPFAILURE
         RETURN "The PrintDlg function failed to load the required resources."
      case nErrCode = CFERR_MAXLESSTHANMIN
         RETURN "The size specified in the nSizeMax member of the CHOOSEFONT structure is less than the size specified in the nSizeMin member."
      case nErrCode = CFERR_NOFONTS
         RETURN "No fonts exist."
      case nErrCode = FNERR_BUFFERTOOSMALL
         RETURN "The buffer pointed to by the lpstrFile member of the OPENFILENAME structure is too small for the filename specified by the user. The first two bytes of the lpstrFile buffer contain an integer value specifying the size, in bytes (ANSI version) or characters (Unicode version), required to receive the full name."
      case nErrCode = FNERR_INVALIDFILENAME
         RETURN "A filename is invalid."
      case nErrCode = FNERR_SUBCLASSFAILURE
         RETURN "An attempt to subclass a list box failed because sufficient memory was not available."
      case nErrCode = FRERR_BUFFERLENGTHZERO
         RETURN "A member of the FINDREPLACE structure points to an invalid buffer."
   ENDCASE
RETURN "Unknown COMMDLG error. Phone Bill."

************************************************************************
* Functions
************************************************************************

PROCEDURE HLOpenFileName
   LOCAL ofn ; ofn = new HLS_OPENFILENAME ()
   * make dialog owned by VdB
   ofn.hWndOwner     = _app.framewin.hwnd
   * customize
   ofn.lpstrFilter   = "All Files (*.*)" + chr (0) + "*.*" + chr (0) + ;
                              "Text Files (*.txt)" + chr (0) + "*.txt" + chr (0) + ;
                              "Doc Files (*.doc)" + chr (0) + "*.doc" + chr (0) + chr (0)
   ofn.lpstrTitle    = "Open Text or Document file"
   ofn.lpstrDefExt   = "txt"

   * call the dialog (the WinAPI that uses the struct function)
   ?
   IF ofn.ExecDialog ()
      ? ofn.lpstrFile
   ELSE
      ? ofn.ErrorMessage
   ENDIF

   * release memory !!!
   ofn.release ()
RETURN

PROCEDURE HLChooseFont
   LOCAL cf ; cf = new HLS_CHOOSEFONT ()
   * make dialog owned by VdB
   cf.hWndOwner            = _app.framewin.hwnd
   * start with this font
   cf.lpLogFont.lfHeight   = 24 * 4 / 3
   cf.lpLogFont.lfFaceName = "Arial"
   cf.Flags                = CF_BOTH + CF_INITTOLOGFONTSTRUCT + CF_EFFECTS

   * call the dialog (the WinAPI that uses the struct function)
   ?
   IF cf.ExecDialog ()
      ? cf.lpLogFont.lfFaceName + "," + ltrim (str (int (abs (cf.lpLogFont.lfHeight) * 3 / 4)))
      ?? iif (cf.lpLogFont.lfWeight      >= 550, ",B", ",")
      ?? iif (cf.lpLogFont.lfItalic      <> 0, "I", "")
      ?? iif (cf.lpLogFont.lfUnderline   <> 0, "U", "")
      ?? iif (cf.lpLogFont.lfStrikeOut   <> 0, "S,", ",")
      LOCAL f ; f = bitand (cf.lpLogFont.lfPitchAndFamily, htoi ("F0"))
      DO CASE
         CASE f = FF_DECORATIVE
            ?? "Decorative"
         CASE f = FF_MODERN
            ?? "Modern"
         CASE f = FF_ROMAN
            ?? "Roman"
         CASE f = FF_SCRIPT
            ?? "Script"
         CASE f = FF_SWISS
            ?? "Swiss"
      ENDCASE
   ELSE
      ? cf.ErrorMessage
   ENDIF

   * release memory !!!
   cf.release ()
RETURN

PROCEDURE HLChooseColor
   PRIVATE cc ; cc = new HLS_CHOOSECOLOR ()
   PRIVATE i, c, cMacro
   * make dialog owned by VdB
   cc.hWndOwner = _app.framewin.hwnd
   * add a gray scale as custom colors
   FOR i = 0 TO 15
      c = i * 17
      cc.lpCustColors [i] = RGB (c, c, c)
   NEXT
   * start with this color
   cc.rgbResult = RGB (192, 128, 64)
   cc.Flags = CC_RGBINIT
   * call the dialog (the WinAPI that uses the struct function)
   ?
   IF cc.ExecDialog ()
      * read the (changed) struct values back
      ? "Chosen Color : " + itoh (cc.rgbResult, 6)
      FOR i = 0 TO 15
         ? "Custom Color " + str (i, 2) + " : " + itoh (cc.lpCustColors [i], 6)
      NEXT
   ELSE
      ? cc.ErrorMessage
   ENDIF

   * release memory !!!
   cc.release ()
RETURN

PROCEDURE HLPrintDlg
   LOCAL pd ; pd = new HLS_PRINTDLG (new HLS_DEVMODE (0), new HLS_DEVNAMES ())
   pd.hWndOwner             = _app.framewin.hwnd
   pd.hDevMode.dmDeviceName = pd.hDevNames.cDevice

   ?
   IF pd.ExecDialog ()
      ? "Print to: " + pd.hDevNames.ToCommaSeparated ()
      DO CASE
         CASE bitand (pd.Flags, PD_PAGENUMS) > 0
            ? "Print pages from " + ltrim (str (pd.nFromPage)) + " to " + ltrim (str (pd.nToPage))
         CASE bitand (pd.Flags, PD_SELECTION) > 0
            ? "Print selection"
         OTHERWISE
            ? "Print all pages"
      ENDCASE
      IF bitand (pd.Flags, PD_COLLATE) > 0
         ? "Print " + ltrim (str (pd.nCopies)) + " collated copies"
      ELSE
         ? "Print " + ltrim (str (pd.hDevMode.dmCopies)) + " not collated copies "
      ENDIF
   ELSE
      ? pd.ErrorMessage
   ENDIF

   * release memory !!!
   pd.release ()
RETURN

#ifdef __vdb__

PROCEDURE HLPageSetupDlg
   LOCAL psd ; psd = new HLS_PAGESETUPDLG (new HLS_DEVMODE (0), new HLS_DEVNAMES ())
   psd.hWndOwner              = _app.framewin.hwnd
   psd.hDevMode.dmDeviceName  = psd.hDevNames.cDevice
   psd.flags                  = PSD_INHUNDREDTHSOFMILLIMETERS

   ?
   IF psd.ExecDialog ()
      LOCAL pi ; pi = new PrinterInfo (psd.hDevNames.cDevice, psd.hDevNames.cDriver, psd.hDevNames.cOutput)
      ? "Paper Size            : ", pi.GetPaperName ((psd.hDevMode.dmPaperSize))
      ? "Paper Orientation     : ", iif (psd.hDevMode.dmOrientation == DMORIENT_PORTRAIT, "Portrait", "Landscape")
      ? "Paper Source          : ", pi.GetBinName   ((psd.hDevMode.dmDefaultSource))
      ? "Margins TLRB (mm/100) : ", psd.rtMargin.top, psd.rtMargin.left, psd.rtMargin.right, psd.rtMargin.bottom
   ELSE
      ? psd.ErrorMessage
   ENDIF

   * release memory !!!
   psd.release ()
RETURN

#else

PROCEDURE HLPrintSetupDlg
   LOCAL psd ; psd = new HLS_PRINTDLG (new HLS_DEVMODE (0), new HLS_DEVNAMES ())
   psd.hWndOwner             = _app.framewin.hwnd
   psd.hDevMode.dmDeviceName = psd.hDevNames.cDevice
   psd.flags = bitor (psd.flags, PD_PRINTSETUP)

   ?
   IF psd.ExecDialog ()
      ? psd.hDevNames.ToCommaSeparated ()
      LOCAL pi ; pi = new PrinterInfo (psd.hDevNames.cDevice, psd.hDevNames.cDriver, psd.hDevNames.cOutput)
      ? "Paper Size            : ", pi.GetPaperName ((psd.hDevMode.dmPaperSize))
      ? "Paper Orientation     : ", iif (psd.hDevMode.dmOrientation == DMORIENT_PORTRAIT, "Portrait", "Landscape")
      ? "Paper Source          : ", pi.GetBinName   ((psd.hDevMode.dmDefaultSource))
   ELSE
      ? psd.ErrorMessage
   ENDIF

   * release memory !!!
   psd.release ()
RETURN

#endif

************************************************************************
* A complete test run
************************************************************************

PROCEDURE HLComDlgTestSuite
   HLOpenFileName ()
   HLChooseFont ()
   HLChooseColor ()
   HLPrintDlg ()
#ifdef __vdb__
   HLPageSetupDlg ()
#else
   HLPrintSetupDlg ()
#endif
RETURN
