***************************************************************************
*  Copyright (C) 1998 Marcello Perathoner. All rights reserved.           *
*  email: JLSeagull@csi.com                                               *
*  http://ourworld.compuserve.com/Homepages/JLSeagull/vdb/index.html      *
***************************************************************************

#define NDEBUG

* close all ; do hlprint.cc ; o = new PrinterInfo ("HP LaserJet III", "HPPCL5MS", "LPT1:") ; inspect (o)

   set procedure to program (1) additive
   InitHLPrint ()
RETURN

#define PRINTDRIVER

#include "hlwinapi.cch"
#include "hlstruct.cch"
#include "hlprint.cch"

#define int 	CINT
#define HWND	HWINDOW

PROCEDURE InitHLPrint
   DO ("hlwinapi.cc")
   DO ("hlstruct.cc")

   IF type ("_app.HLPrint_CC") == "L"
      RETURN
   ENDIF
   _app.HLPrint_CC = .t.

   extern   HDC     WINAPIResetDC           (HDC, CLONG)             GDI from "ResetDC" U

#ifndef __vdb__
#ifdef PRINTDRIVER
   * Printer Queue ?
   * Not really sure of these
   extern   HPQ     WINAPICreatePQ          (int)                    GDI from "CreatePQ"
   extern   int     WINAPIMinPQ             (HPQ)                    GDI from "MinPQ"
   extern   int     WINAPIExtractPQ         (HPQ)                    GDI from "ExtractPQ"
   extern   int     WINAPIInsertPQ          (HPQ, int, int)          GDI from "InsertPQ"
   extern   int     WINAPISizePQ            (HPQ, int)               GDI from "SizePQ"
   extern   void    WINAPIDeletePQ          (HPQ)                    GDI from "DeletePQ"

   * Spool routines for use by printer drivers
   * Not really sure of these either
   extern   HPJOB   WINAPIOpenJob           (LPSTR, LPSTR, HDC)      GDI from "OpenJob"
   extern   int     WINAPIStartSpoolPage    (HPJOB)                  GDI from "StartSpoolPage"
   extern   int     WINAPIEndSpoolPage      (HPJOB)                  GDI from "EndSpoolPage"
   extern   int     WINAPIWriteSpool        (HPJOB, LPSTR, int)      GDI from "WriteSpool"
   extern   int     WINAPICloseJob          (HPJOB)                  GDI from "CloseJob"
   extern   int     WINAPIDeleteJob         (HPJOB, int)             GDI from "DeleteJob"
   extern   int     WINAPIWriteDialog       (HPJOB, LPSTR, int)      GDI from "WriteDialog"
   extern   int     WINAPIDeleteSpoolPage   (HPJOB)                  GDI from "DeleteSpoolPage"
#endif
#endif

RETURN

CLASS HLS_BANDINFOSTRUCT OF HLStruct
    HLS_BOOL("fGraphics")
    HLS_BOOL("fText")
    HLS_INLINEDSTRUCT("rcGraphics", new HLSRECT ())
ENDCLASS

CLASS HLS_DEVMODE (nExtra) OF HLStruct
   * nExtra = size of private driver data field
   HLS_BCHARS("dmDeviceName", CCHDEVICENAME)
   HLS_WORD("dmSpecVersion")
   HLS_WORD("dmDriverVersion")
   HLS_WORD("dmSize")
   HLS_WORD("dmDriverExtra")
   HLS_DWORD("dmFields")
   HLS_short("dmOrientation")
   HLS_short("dmPaperSize")
   HLS_short("dmPaperLength")
   HLS_short("dmPaperWidth")
   HLS_short("dmScale")
   HLS_short("dmCopies")
   HLS_short("dmDefaultSource")
   HLS_short("dmPrintQuality")
   HLS_short("dmColor")
   HLS_short("dmDuplex")
   HLS_short("dmYResolution")
   HLS_short("dmTTOption")

#if (WINVER >= htoi ("0400"))
   HLS_short("dmCollate")
   HLS_BCHARS("dmFormName", CCHFORMNAME)
   HLS_WORD("dmLogPixels")
   HLS_DWORD("dmBitsPerPel")
   HLS_DWORD("dmPelsWidth")
   HLS_DWORD("dmPelsHeight")
   HLS_DWORD("dmDisplayFlags")
   HLS_DWORD("dmDisplayFrequency")
   HLS_DWORD("dmICMMethod")            && Windows 95 only
   HLS_DWORD("dmICMIntent")            && Windows 95 only
   HLS_DWORD("dmMediaType")            && Windows 95 only
   HLS_DWORD("dmDitherType")           && Windows 95 only
   HLS_DWORD("dmReserved1")            && Windows 95 only
   HLS_DWORD("dmReserved2")            && Windows 95 only
#endif
   this.dmSize          = this.GetSize ()

   * add private driver-data field if necessary
   IF nExtra > 0
      HLS_CHARS("dmExtra", nExtra)
      this.dmDriverExtra = nExtra
   ENDIF

   * set some "meaningful" defaults
   this.dmFields        = DM_ORIENTATION + DM_PAPERSIZE + DM_SCALE + ;
                          DM_COPIES + DM_DEFAULTSOURCE + DM_PRINTQUALITY
   this.dmOrientation   = DMORIENT_PORTRAIT
   this.dmPaperSize     = DMPAPER_A4   && change this for odd paper
   this.dmScale         = 100
   this.dmDefaultSource = DMBIN_FIRST
   this.dmPrintQuality  = DMRES_HIGH
   this.dmCopies        = 1
ENDCLASS

CLASS HLS_SCREENPARAMS OF HLStruct
   HLS_int("angle")
   HLS_int("frequency")
ENDCLASS

CLASS HLS_DEVCAP_WORDARRAY (nElements) OF HLSArray
   LOCAL i
   FOR i = 1 TO nElements
      HLS_WORD(i)
   NEXT
ENDCLASS

CLASS HLS_DEVCAP_BYTEARRAYARRAY (nElements, nSize) OF HLSArray
   LOCAL i
   FOR i = 1 TO nElements
      HLS_CHARS(i, nSize)
   NEXT
ENDCLASS

CLASS HLS_DEVCAP_POINTLARRAY (nElements) OF HLSArray
   LOCAL i
   FOR i = 1 TO nElements
      HLS_INLINEDSTRUCT(i, new HLS_POINTL ())
   NEXT
ENDCLASS

CLASS HLS_DEVCAP_POINTARRAY (nElements) OF HLSArray
   LOCAL i
   FOR i = 1 TO nElements
      HLS_INLINEDSTRUCT(i, new HLS_POINT ())
   NEXT
ENDCLASS

CLASS HLS_PRINTERSINFO_BYTEARRAY (nSize) OF HLSArray
   new HLSByteArray (new HLSAnsiDecorator (this), "info", nSize)
ENDCLASS

CLASS PrintersInfo
   this.Query ()

   PROCEDURE Query
      this.aPrinters = new array ()
      *
      * get default printer
      *
      LOCAL xBuf ; xBuf = space (1024)
      LOCAL nLen ; nLen = WinAPIGetProfileString ("Windows", "Device", "", xBuf, len (xBuf) * SIZEOF_VDBCHAR)
      LOCAL lHasDefault ; lHasDefault = false
      IF nLen > 0
         LOCAL aValues ; aValues = tokenize (left (xBuf, nLen), ",")
         this.oDefault = new object ()
         this.oDefault.Device   = aValues [1]
         this.oDefault.Driver   = aValues [2]
         this.oDefault.Port     = aValues [3]
         lHasDefault = true
      ENDIF
      *
      * get installed printers
      *
      extern DWORD _WinAPIGetProfileString (LPCSTR, LPCSTR, LPCSTR, LPSTRUCT, DWORD) kernel from "GetProfileString" U
      LOCAL oBuf ; oBuf = new HLS_PRINTERSINFO_BYTEARRAY (1024)
      nLen = _WinAPIGetProfileString ("Devices", 0, "", oBuf.put (), oBuf.GetSize ())
      oBuf.get ()
      oBuf.release ()
      _WinAPIGetProfileString = NULL

      IF nLen > 0
         LOCAL aEntries ; aEntries = tokenize (left (oBuf.info, nLen - 1), chr (0))
         LOCAL nIndex
         FOR nIndex = 1 TO alen (aEntries)
            nLen = WinAPIGetProfileString ("Devices", aEntries [nIndex], "", xBuf, len (xBuf) * SIZEOF_VDBCHAR)
            IF nLen > 0
               LOCAL aValues  ; aValues = tokenize (left (xBuf, nLen - 1), ",")
               LOCAL oPrinter ; oPrinter = new object ()
               oPrinter.Device   = aEntries [nIndex]
               oPrinter.Driver   = aValues [1]
               oPrinter.Port     = aValues [2]
               oPrinter.lDefault = false
               IF lHasDefault
                  oPrinter.lDefault = oPrinter.Device == this.oDefault.Device ;
                     .and. oPrinter.Driver == this.oDefault.Driver ;
                     .and. oPrinter.Port   == this.oDefault.Port
               ENDIF
               this.aPrinters.add (oPrinter)
            ENDIF
         NEXT
      ENDIF
   RETURN
ENDCLASS

CLASS PrinterInfo (cDevice, cDriver, cPort)
   PROTECT DevCap
   this.cDevice = cDevice
   this.cDriver = cDriver
   this.cPort   = cPort
   this.QueryCaps ()

   PROCEDURE DevCap (nList)
   RETURN _WinAPIDeviceCapabilities (this.cDevice, this.cPort, nList, 0, 0)

   PROCEDURE QueryCaps
      private cDriver ; cDriver = this.cDriver + ".DRV"
#ifdef WINVER_400
      cDriver = "winspool.drv"
#endif
      private  lDevCapSupported ; lDevCapSupported = .t.
      on error lDevCapSupported = .f.
      * test if function DeviceCapabilities is supported by the driver
      extern LONG _WinAPIDeviceCapabilities (LPCTSTR, LPCTSTR, WORD, LPSTRUCT, LPSTRUCT) &cDriver. from "DeviceCapabilities" U
      on error

      IF lDevCapSupported
         LOCAL nCnt

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERS, 0, 0)
         IF nCnt <> -1
            this.aPapers = new HLS_DEVCAP_WORDARRAY (nCnt)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERS, this.aPapers.put (), 0)
            this.aPapers.get ()
            this.aPapers.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_BINS, 0, 0)
         IF nCnt <> -1
            this.aBins = new HLS_DEVCAP_WORDARRAY (nCnt)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_BINS, this.aBins.put (), 0)
            this.aBins.get ()
            this.aBins.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERNAMES, 0, 0)
         IF nCnt <> -1
            this.aPaperNames = new HLS_DEVCAP_BYTEARRAYARRAY (nCnt, CCHPAPERNAME)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERNAMES, this.aPaperNames.put (), 0)
            this.aPaperNames.get ()
            this.aPaperNames.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_BINNAMES, 0, 0)
         IF nCnt <> -1
            this.aBinNames = new HLS_DEVCAP_BYTEARRAYARRAY (nCnt, CCHBINNAME)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_BINNAMES, this.aBinNames.put (), 0)
            this.aBinNames.get ()
            this.aBinNames.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_FILEDEPENDENCIES, 0, 0)
         IF nCnt <> -1
            this.aFileDependencies = new HLS_DEVCAP_BYTEARRAYARRAY (nCnt, 64)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_FILEDEPENDENCIES, this.aFileDependencies.put (), 0)
            this.aFileDependencies.get ()
            this.aFileDependencies.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_ENUMRESOLUTIONS, 0, 0)
         IF nCnt <> -1
            this.aResolutions = new HLS_DEVCAP_POINTLARRAY (nCnt)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_ENUMRESOLUTIONS, this.aResolutions.put (), 0)
            this.aResolutions.get ()
            this.aResolutions.release ()
         ENDIF

         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERSIZE, 0, 0)
         IF nCnt <> -1
            this.aPaperSizes = new HLS_DEVCAP_POINTARRAY (nCnt)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_PAPERSIZE, this.aPaperSizes.put (), 0)
            this.aPaperSizes.get ()
            this.aPaperSizes.release ()
         ENDIF

         this.oMaxExtent = new HLS_POINTS ()
         _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_MAXEXTENT, this.oMaxExtent.put (), 0)
         this.oMaxExtent.get ()
         this.oMaxExtent.release ()

         this.oMinExtent = new HLS_POINTS ()
         _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_MINEXTENT, this.oMinExtent.put (), 0)
         this.oMinExtent.get ()
         this.oMinExtent.release ()

         this.nCopies            = this.DevCap (DC_COPIES)
         this.nVersion           = this.DevCap (DC_DRIVER)
         this.nSpecVersion       = this.DevCap (DC_VERSION)
         this.lCanDuplex         = this.DevCap (DC_DUPLEX) > 0
         this.nOrientation       = this.DevCap (DC_ORIENTATION)
         this.nSize              = this.DevCap (DC_SIZE)
         this.nExtra             = this.DevCap (DC_EXTRA)
         this.nFields            = this.DevCap (DC_FIELDS)
         this.nTTOption          = this.DevCap (DC_TRUETYPE)

#ifdef WINVER_400
         nCnt = _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_DATATYPE_PRODUCED, 0, 0)
         IF nCnt <> -1
            this.aDatatypesProduced = new HLS_DEVCAP_BYTEARRAYARRAY (nCnt, 4)
            _WinAPIDeviceCapabilities (this.cDevice, this.cPort, DC_DATATYPE_PRODUCED, this.aDatatypesProduced.put (), 0)
            this.aDatatypesProduced.get ()
            this.aDatatypesProduced.release ()
         ENDIF

         this.nBinAdjust         = this.DevCap (DC_BINADJUST)
         this.lEMFCompliant      = this.DevCap (DC_EMF_COMPLIANT) > 0
         this.lCollate           = this.DevCap (DC_COLLATE) > 0
#endif
      ENDIF

      _WinAPIDeviceCapabilities  = NULL
   RETURN

   PROCEDURE GetPaperName (nIndex)
      LOCAL i
      * some buggy drivers dont even get this right
      LOCAL cnt ; cnt = min (this.aPapers.GetFieldCount (), this.aPaperNames.GetFieldCount ())
      FOR i = 1 TO cnt
         IF this.aPapers [i] == nIndex
            RETURN this.aPaperNames [i]
         ENDIF
      NEXT
   RETURN ""

   PROCEDURE GetBinName (nIndex)
      LOCAL i
      * some buggy drivers dont even get this right
      LOCAL cnt ; cnt = min (this.aBins.GetFieldCount (), this.aBinNames.GetFieldCount ())
      FOR i = 1 TO cnt
         IF this.aBins [i] == nIndex
            RETURN this.aBinNames [i]
         ENDIF
      NEXT
   RETURN ""

ENDCLASS

