***************************************************************************
*  Copyright (C) 1998 Marcello Perathoner. All rights reserved.           *
*  email: JLSeagull@csi.com                                               *
*  http://ourworld.compuserve.com/Homepages/JLSeagull/vdb/index.html      *
***************************************************************************

#define NDEBUG

   set procedure to program (1) additive
   DO hlstruct.cc
RETURN

#include "hlwinapi.cch"
#include "hlstruct.cch"

************************************************************************
* HLStructTest
************************************************************************
* some assorted tests
* mainly to test if any size integers are handled correctly
************************************************************************

CLASS HLS_PT OF HLStruct
   HLS_INT("x")
   HLS_INT("y")
ENDCLASS

CLASS HLS_INTARRAY (nSize) OF HLStruct
   LOCAL i
   FOR i = 0 TO nSize - 1
      HLS_INT(i)
   NEXT

ENDCLASS

CLASS TESTSTRUCT OF HLStruct
   HLS_SHORT("i1")
   HLS_SHORT("i2")
   HLS_SHORT("i3")
   HLS_SHORT("i4")
   HLS_USHORT("ui1")
   HLS_USHORT("ui2")
   HLS_USHORT("ui3")
   HLS_USHORT("ui4")

   HLS_LONG("l1")
   HLS_LONG("l2")
   HLS_LONG("l3")
   HLS_LONG("l4")
   HLS_ULONG("ul1")
   HLS_ULONG("ul2")
   HLS_ULONG("ul3")
   HLS_ULONG("ul4")

   HLS_LPWSTR("s1")
   HLS_INLINEDSTRUCT("p1", new HLS_PT ())
   HLS_TCHARS("s2", 32)
   HLS_LPSTRUCT("p2", new HLS_PT ())
   HLS_LPWSTR("s3")
   HLS_INLINEDSTRUCT("a1", new HLS_INTARRAY (4))
ENDCLASS

PROCEDURE HLStructTest
   clear
   LOCAL s ; s = new TESTSTRUCT ()

   * Load test values
   s.i1    = 0
   s.i2    = -1
   s.i3    = htoi ("7FFF")
   s.i4    = -htoi ("8000")
   s.ui1   = 0
   s.ui2   = htoi ("FFFF")
   s.ui3   = htoi ("7FFF")
   s.ui4   = htoi ("8000")

   s.l1    = 0
   s.l2    = -1
   s.l3    = htoi ("7FFFFFFF")
   s.l4    = -htoi ("80000000")
   s.ul1   = 0
   s.ul2   = htoi ("FFFFFFFF")
   s.ul3   = htoi ("7FFFFFFF")
   s.ul4   = htoi ("80000000")

   s.s1    = "This is a Unicode test string"
   s.s2    = "This is an Ansi test string"
   s.s3    = NULL

   s.p1.x  = -1
   s.p1.y  = -2
   s.p2.x  = -3
   s.p2.y  = -4

   s.a1 [0] = 4711
   s.a1 [1] = 4712
   s.a1 [2] = 4713
   s.a1 [3] = 4714

   * build struct them
   s.put ()

#ifndef NDEBUG
   * dump memory structure
   s.PrintDebugInfo ()
#endif

   * set easily recognizable wrong values
   s.i1    = 7
   s.i2    = 7
   s.i3    = 7
   s.i4    = 7
   s.ui1   = 7
   s.ui2   = 7
   s.ui3   = 7
   s.ui4   = 7

   s.l1    = 7
   s.l2    = 7
   s.l3    = 7
   s.l4    = 7
   s.ul1   = 7
   s.ul2   = 7
   s.ul3   = 7
   s.ul4   = 7

   s.s1    = "Error"
   s.s2    = "Error"
   s.s3    = "Error"

   s.p1.x  = 7
   s.p1.y  = 7
   s.p2.x  = 7
   s.p2.y  = 7

   s.a1 [0] = 7
   s.a1 [1] = 7
   s.a1 [2] = 7
   s.a1 [3] = 7

   * scan structure
   * this should overwrite the wrong
   * values with the correct ones
   s.get ()

   * output "get"ed values
   ? s.i1
   ? s.i2
   ? s.i3
   ? s.i4
   ? s.ui1
   ? s.ui2
   ? s.ui3
   ? s.ui4

   ? s.l1
   ? s.l2
   ? s.l3
   ? s.l4
   ? s.ul1
   ? s.ul2
   ? s.ul3
   ? s.ul4

   ? s.s1
   ? s.s2
   ? s.s3

   ? s.p1.x
   ? s.p1.y
   ? s.p2.x
   ? s.p2.y

   ? s.a1 [0]
   ? s.a1 [1]
   ? s.a1 [2]
   ? s.a1 [3]

   s.release ()
RETURN

************************************************************************
* HLBitmapInfo
************************************************************************
* open a bitmap on disk and read the header information
* example of a file based structure
************************************************************************

* close all ; do hlstructtest ; HLBitmapInfo ("c:\windows\setup.bmp")

CLASS BITMAPFILEHEADER OF HLStruct
   HLS_WORD("bfType")
   HLS_DWORD("bfSize")
   HLS_WORD("bfReserved1")
   HLS_WORD("bfReserved2")
   HLS_DWORD("bfOffBits")
ENDCLASS

CLASS BITMAPINFOHEADER OF HLStruct
   HLS_DWORD("biSize")
   HLS_LONG("biWidth")
   HLS_LONG("biHeight")
   HLS_WORD("biPlanes")
   HLS_WORD("biBitCount")
   HLS_DWORD("biCompression")
   HLS_DWORD("biSizeImage")
   HLS_LONG("biXPelsPerMeter")
   HLS_LONG("biYPelsPerMeter")
   HLS_DWORD("biClrUsed")
   HLS_DWORD("biClrImportant")
ENDCLASS

CLASS RGBQUAD OF HLStruct
   HLS_BYTE("rgbBlue")
   HLS_BYTE("rgbGreen")
   HLS_BYTE("rgbRed")
   HLS_BYTE("rgbReserved")
ENDCLASS

PROCEDURE HLBitmapInfo (cFileName)
   LOCAL fp ; fp = new HLFile ()
   fp.fopen (cFileName, "r")
   IF fp.ok ()
      LOCAL bmfh ; bmfh = new BITMAPFILEHEADER ()
      fp.fread (bmfh.GetMem (), bmfh.GetSize ())
      bmfh.get ()
#ifndef NDEBUG
      bmfh.PrintDebugInfo ()
#endif
      IF bmfh.bfType == asc ("B") + 256 * asc ("M")
         LOCAL bmih ; bmih = new BITMAPINFOHEADER ()
         fp.fread (bmih.GetMem (), bmih.GetSize ())
         bmih.get ()
#ifndef NDEBUG
         bmih.PrintDebugInfo ()
#endif
         IF bmih.biSize == bmih.GetSize ()
            ? "Width     : ", bmih.biWidth
            ? "Height    : ", bmih.biHeight
            ? "BitCount  : ", bmih.biBitCount
            ? "Colors    : ", bmih.biClrUsed
            ? "Important : ", bmih.biClrImportant
            ? "X pix / m : ", bmih.biXPelsPerMeter
            ? "Y pix / m : ", bmih.biYPelsPerMeter
         ELSE
            ? "Bitmap is corrupt : " + cFileName
         ENDIF
         bmih.release ()
      ELSE
         ? "Not a bitmap: " + cFileName
      ENDIF
      bmfh.release ()
      fp.fclose ()
   ELSE
      ? "File " + cFileName + " not found"
   ENDIF
RETURN

#ifdef __vdb__

************************************************************************
* HLEnumPrinters
************************************************************************
* enumerate local printers
* test of "weird" structures and arrays
************************************************************************

CLASS PRINTER_INFO_1 OF HLStruct
   HLS_DWORD("Flags")
   HLS_LPTSTR("pDescription")
   HLS_LPTSTR("pName")
   HLS_LPTSTR("pComment")
ENDCLASS

CLASS PRINTER_INFO_1_ARRAY (nSize) OF HLStruct
   LOCAL i
   FOR i = 0 TO nSize - 1
      HLS_INLINEDSTRUCT(i, new PRINTER_INFO_1 ())
   NEXT
ENDCLASS

#define PRINTER_ENUM_DEFAULT     htoi ("00000001")
#define PRINTER_ENUM_LOCAL       htoi ("00000002")
#define PRINTER_ENUM_CONNECTIONS htoi ("00000004")
#define PRINTER_ENUM_FAVORITE    htoi ("00000004")
#define PRINTER_ENUM_NAME        htoi ("00000008")
#define PRINTER_ENUM_REMOTE      htoi ("00000010")
#define PRINTER_ENUM_SHARED      htoi ("00000020")
#define PRINTER_ENUM_NETWORK     htoi ("00000040")

#define PRINTER_ENUM_EXPAND      htoi ("00004000")
#define PRINTER_ENUM_CONTAINER   htoi ("00008000")

#define PRINTER_ENUM_ICONMASK    htoi ("00ff0000")
#define PRINTER_ENUM_ICON1       htoi ("00010000")
#define PRINTER_ENUM_ICON2       htoi ("00020000")
#define PRINTER_ENUM_ICON3       htoi ("00040000")
#define PRINTER_ENUM_ICON4       htoi ("00080000")
#define PRINTER_ENUM_ICON5       htoi ("00100000")
#define PRINTER_ENUM_ICON6       htoi ("00200000")
#define PRINTER_ENUM_ICON7       htoi ("00400000")
#define PRINTER_ENUM_ICON8       htoi ("00800000")

PROCEDURE HLEnumPrinters
   extern BOOL EnumPrintersA (DWORD, LPTSTR, DWORD, CPTR, DWORD, CPTR DWORD, CPTR DWORD) winspool.drv
   LOCAL nNeeded ; nNeeded = 0
   LOCAL nReturned ; nReturned = 0

   * first call needed to get buffer size
   * will fail (_must_ fail !)
   IF .not. EnumPrintersA (PRINTER_ENUM_LOCAL, NULL, 1, NULL, 0, nNeeded, nReturned)
      * second call to get data and number of items
      * allocate a buffer
      LOCAL mem ; mem = new HLMem ()
      mem.malloc (nNeeded)
      EnumPrintersA (PRINTER_ENUM_LOCAL, NULL, 1, mem.GetAddr (), nNeeded, nNeeded, nReturned)
      * now we know what the struct is
      * an array of nNeeded PRINTER_INFO_1 structs
      * build the struct and load it from mem
      LOCAL pia ; pia = new PRINTER_INFO_1_ARRAY (nReturned)
      pia.FromMem (mem)
      pia.get ()
      ?
      ? "Printers: "
      ?
      FOR i = 0 TO nReturned - 1
         ? pia [i].pName
         IF len (pia [i].pComment) > 0
            ?? " (" + pia [i].pComment + ")"
         ENDIF
      NEXT
      ?
      pia.release ()
      mem.release ()
   ENDIF
RETURN

#endif
